import isPromise from '../helpers/isPromise';

var _runner = function _runner(_temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      instance = _ref.instance,
      original = _ref.original;

  return function () {
    try {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var returns = original.apply(instance, args);
      return isPromise(returns) ? returns.then(function (r) {
        return [null, r];
      }).catch(function (e) {
        return [e, null];
      }) : [null, returns];
    } catch (e) {
      return [e, null];
    }
  };
};

export default (function (target, fnName, descriptor) {
  var fn = descriptor.value,
      configurable = descriptor.configurable,
      enumerable = descriptor.enumerable; // https://github.com/jayphelps/core-decorators.js/blob/master/src/autobind.js

  return Object.assign({}, {
    configurable: configurable,
    enumerable: enumerable,
    get: function get() {
      if (this === target) {
        return fn;
      }

      var _fnRunner = _runner({
        instance: this,
        original: fn
      });

      Object.defineProperty(this, fnName, {
        configurable: true,
        writable: true,
        enumerable: false,
        value: _fnRunner
      });
      return _fnRunner;
    },
    set: function set(newValue) {
      Object.defineProperty(this, fnName, {
        configurable: true,
        writable: true,
        enumerable: true,
        value: newValue
      });
      return newValue;
    }
  });
});